Cartographer_Import = AceLibrary("AceAddon-2.0"):new("AceConsole-2.0", "AceEvent-2.0")

local L = AceLibrary("AceLocale-2.2"):new("Cartographer_Import")

L:RegisterTranslations("enUS", function() return {
	["Added %s %s to %s at %.2f, %.2f from %s"] = true,
	
	["Mineral"] = true,
	["Herb"] = true,
	["Treasure"] = true,
	["Gatherer"] = true,
	["Fishing"] = true,
} end)

L:RegisterTranslations("koKR", function() return {
	["Added %s %s to %s at %.2f, %.2f from %s"] = "Added %s %s to %s at %.2f, %.2f from %s",

	["Mineral"] = "광물",
	["Herb"] = "약초",
	
	["Gatherer"] = "채집",
} end)

L:RegisterTranslations("zhTW", function() return {
	["Added %s %s to %s at %.2f, %.2f from %s"] = "加入 %s %s 到 %s 座標 %.2f, %.2f，來自 %s",
	
	["Mineral"] = "礦石",
	["Herb"] = "草藥",
	
	--["Gatherer"] = true,
} end)

L:RegisterTranslations("esES", function() return {
	["Added %s %s to %s at %.2f, %.2f from %s"] = "A\195\177adido %s %s a %s en %.2f, %.2f desde %s",
	
	["Mineral"] = "Mineral",
	["Herb"] = "Hierba",
	["Treasure"] = "Tesoro",
	["Gatherer"] = "Gatherer",
	["Fishing"] = "Pesca",
} end)

local BZ = AceLibrary("Babble-Zone-2.2")

local zones = {
	[1] = {
		BZ["Ashenvale"],
		BZ["Azshara"],
		BZ["Darkshore"],
		BZ["Darnassus"],
		BZ["Desolace"],
		BZ["Durotar"],
		BZ["Dustwallow Marsh"],
		BZ["Felwood"],
		BZ["Feralas"],
		BZ["Moonglade"],
		BZ["Mulgore"],
		BZ["Orgrimmar"],
		BZ["Silithus"],
		BZ["Stonetalon Mountains"],
		BZ["Tanaris"],
		BZ["Teldrassil"],
		BZ["The Barrens"],
		BZ["Thousand Needles"],
		BZ["Thunder Bluff"],
		BZ["Un'Goro Crater"],
		BZ["Winterspring"],
	},
	[2] = {
		BZ["Alterac Mountains"],
		BZ["Arathi Highlands"],
		BZ["Badlands"],
		BZ["Blasted Lands"],
		BZ["Burning Steppes"],
		BZ["Deadwind Pass"],
		BZ["Dun Morogh"],
		BZ["Duskwood"],
		BZ["Eastern Plaguelands"],
		BZ["Elwynn Forest"],
		BZ["Hillsbrad Foothills"],
		BZ["Ironforge"],
		BZ["Loch Modan"],
		BZ["Redridge Mountains"],
		BZ["Searing Gorge"],
		BZ["Silverpine Forest"],
		BZ["Stormwind City"],
		BZ["Stranglethorn Vale"],
		BZ["Swamp of Sorrows"],
		BZ["The Hinterlands"],
		BZ["Tirisfal Glades"],
		BZ["Undercity"],
		BZ["Western Plaguelands"],
		BZ["Westfall"],
		BZ["Wetlands"],
	}
}
table.sort(zones[1])
table.sort(zones[2])

local gathererMineralsToCartographer = {
	["copper"] = "Copper",
	["tin"] = "Tin",
	["iron"] = "Iron",
	["iron"] = "Iron",
	["iron"] = "Iron",
	["silver"] = "Silver",
	["truesilver"] = "Truesilver",
	["gold"] = "Gold",
	["mithril"] = "Mithril",
	["thorium"] = "Thorium",
	["thorium (rich)"] = "Rich Thorium",
	["dark iron"] = "Dark Iron",
	
	["copper vein"] = "Copper",
	["tin vein"] = "Tin",
	["iron deposit"] = "Iron",
	["silver vein"] = "Silver",
	["truesilver deposit"] = "Truesilver",
	["gold vein"] = "Gold",
	["mithril deposit"] = "Mithril",
	["small thorium vein"] = "Thorium",
	["rich thorium vein"] = "Rich Thorium",
	["dark iron deposit"] = "Dark Iron",
}

local gathererHerbsToCartographer = {
	["arthas' tears"] = "Arthas' Tears",
	["black lotus"] = "Black Lotus",
	["blindweed"] = "Blindweed",
	["briarthorn"] = "Briarthorn",
	["bruiseweed"] = "Bruiseweed",
	["dreamfoil"] = "Dreamfoil",
	["earthroot"] = "Earthroot",
	["fadeleaf"] = "Fadeleaf",
	["firebloom"] = "Firebloom",
	["ghost mushroom"] = "Ghost Mushroom",
	["golden sansam"] = "Golden Sansam",
	["goldthorn"] = "Goldthorn",
	["grave moss"] = "Grave Moss",
	["gromsblood"] = "Gromsblood",
	["icecap"] = "Icecap",
	["khadgar's whisker"] = "Khadgar's Whisker",
	["kingsblood"] = "Kingsblood",
	["liferoot"] = "Liferoot",
	["mageroyal"] = "Mageroyal",
	["mountain silversage"] = "Mountain Silversage",
	["peacebloom"] = "Peacebloom",
	["plaguebloom"] = "Plaguebloom",
	["purple lotus"] = "Purple Lotus",
	["silverleaf"] = "Silverleaf",
	["stranglekelp"] = "Stranglekelp",
	["sungrass"] = "Sungrass",
	["swiftthistle"] = "Swiftthistle",
	["wild steelbloom"] = "Wild Steelbloom",
	["wintersbite"] = "Wintersbite",
	["wildvine"] ="Wildvine"
}
local gathererFishingToCartographer = {
	["floating wreckage"] = "Floating Wreckage",
	["school"] = "School",
}
local gathererTreasureToCartographer = {
	["abercrombie's crate"] = "Abercrombie's Crate",
	["alexston's chest"] = "Alexston's Chest",
	["alliance chest"] = "Alliance Chest",
	["ammo crate"] = "Ammo Crate",
	["arena treasure chest"] = "Arena Treasure Chest",
	["armor crate"] = "Armor Crate",
--	["atal'ai artifact"] = "Atal'ai Artifact",
	["barrel of melon juice"] = "Barrel Of Melon Juice",
	["barrel of milk"] = "Barrel Of Milk",
	["barrel of sweet nectar"] = "Barrel Of Sweet Nectar",
	["battered chest"] = "Battered Chest",
	["blood of heroes"] = "Blood Of Heroes",
	["bloodpetal sprout"] = "Bloodpetal Sprout",
	["box of assorted parts"] = "Box Of Assorted Parts",
	["broken barrel"] = "Broken Barrel",
	["caravan chest"] = "Caravan Chest",
	["chest of containment coffers"] = "Chest Of Containment Coffers",
--	["cleansed songflower"] = "Cleansed Songflower",
	["crate of foodstuffs"] = "Crate Of Foodstuffs",
	["crate with holes"] = "Crate With Holes",
	["damaged chest"] = "Damaged Chest",
	["damaged crate"] = "Damaged Crate",
	["document chest"] = "Document Chest",
	["excavation supply crate"] = "Excavation Supply Crate",
	["felix's box"] = "Felix's Box",
	["felix's chest"] = "Felix's Chest",
	["food crate"] = "Food Crate",
	["giant clam"] = "Giant Clam",
	["gizmorium shipping crate"] = "Gizmorium Shipping Crate",
	["horde chest"] = "Horde Chest",
	["horde supply crate"] = "Horde Supply Crate",
--	["janice's parcel"] = "Janice's Parcel",
--	["joseph redpath's monument"] = "Joseph Redpath's Monument",
	["karnitol's chest"] = "Karnitol's Chest",
	["kerlonian's chest"] = "Kerlonian's Chest",
	["locked chest"] = "Locked Chest",
	["malem chest"] = "Malem Chest",
	["marshal haggard's chest"] = "Marshal Haggard's Chest",
	["marvon's chest"] = "Marvon's Chest",
--	["pamela's doll's head"] = "Pamela's Doll's Head",
--	["pamela's doll's right side"] = "Pamela's Doll's Right Side",
--	["pamela's doll's left side"] = "Pamela's Doll's Left Side",
	["perrine's chest"] = "Perrine's Chest",
	["rusty chest"] = "Rusty Chest",
	["scattered crate"] = "Scattered Crate",
--	["school"] = "School",
--	["scourge cauldron"] = "Scourge Cauldron",
	["sealed barrel"] = "Sealed Barrel",
	["sealed supply crate"] = "Sealed Supply Crate",
	["shay's chest"] = "Shay's Chest",
	["solid chest"] = "Solid Chest",
	["stolen iron chest"] = "Stolen Iron Chest",
	["sunken chest"] = "Sunken Chest",
	["trelane's chest"] = "Trelane's Chest",
	["un'goro dirt pile"] = "Un'Goro Dirt Pile",
	["un'goro soil"] = "Un'Goro Dirt Pile",
	["water barrel"] = "Water Barrel",
	["weapon crate"] = "Weapon Crate",
	["worn wooden chest"] = "Worn Wooden Chest",	
	["box"] = "Box",
	["chest"] = "Chest",
	["giant clam"] = "Clam",
	["crate"] = "Box",
	["barrel"] = "Barrel",
	["cask"] = "Barrel",
	["shellfish trap"] = "Shellfish Trap",
	["blood of heroes"] = "Blood of Heroes",
	["footlocker"] = "Footlocker",
	["bloodpetal"] = "Bloodpetal Sprout",
	["power crystal"] = "Power Crystal",
}

function Cartographer_Import:OnEnable()
	local hasMining = Cartographer:HasModule(AceLibrary("Babble-Spell-2.2")["Mining"])
	local hasHerb = Cartographer:HasModule(AceLibrary("Babble-Spell-2.2")["Herbalism"])
	local hasFishing = Cartographer:HasModule(AceLibrary("Babble-Spell-2.2")["Fishing"])
	local hasTreasure = Cartographer:HasModule(L["Treasure"])
	if GatherItems then
		for continent, cdata in pairs(GatherItems) do
			for zone, zdata in pairs(cdata) do
				-- fixes errored up import for gather data in the wrong zone
				if zone == 0 then zone = 1 end
				if continent == 0 then continent = 1 end
				-- end import fix
				local zname = BZ:GetReverseTranslation(zones[continent][zone])
				for item, idata in pairs(zdata) do
					if gathererMineralsToCartographer[item] and hasMining then
						for _,v in ipairs(idata) do
							if Cartographer_Notes:SetNote(zname, v.x/100, v.y/100, gathererMineralsToCartographer[item], "Mining") then
								self:Print(L["Added %s %s to %s at %.2f, %.2f from %s"], L["Mineral"], gathererMineralsToCartographer[item], zname, v.x, v.y, "Gatherer")
							end
						end
					elseif gathererHerbsToCartographer[item] and hasHerb then
						for _,v in ipairs(idata) do
							if Cartographer_Notes:SetNote(zname, v.x/100, v.y/100, gathererHerbsToCartographer[item], "Herbalism") then
								self:Print(L["Added %s %s to %s at %.2f, %.2f from %s"], L["Herb"], gathererHerbsToCartographer[item], zname, v.x, v.y, "Gatherer")
							end
						end
					elseif gathererFishingToCartographer[item] and hasFishing then
						for _,v in ipairs(idata) do
							if Cartographer_Notes:SetNote(zname, v.x/100, v.y/100, gathererFishingToCartographer[item], "Fishing") then
								self:Print(L["Added %s %s to %s at %.2f, %.2f from %s"], L["Fishing"], gathererFishingToCartographer[item], zname, v.x, v.y, "Gatherer")
							end
						end
					elseif gathererTreasureToCartographer[item] and hasTreasure then
						for _,v in ipairs(idata) do
							--if Cartographer_Notes:SetNote(zname, v.x/100, v.y/100, gathererTreasureToCartographer[item], "Treasure") then
							if Cartographer_Treasure:ImportNote(zname,v.x/100,v.y/100,gathererTreasureToCartographer[item]) then
								self:Print(L["Added %s %s to %s at %.2f, %.2f from %s"], L["Treasure"], gathererTreasureToCartographer[item], zname, v.x, v.y, "Gatherer")
							end
						end
					end
				end
			end
		end
	end
	self:Print("Done importing notes")
end
